diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-emlsr-test.cc ns-3.43/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.42/src/wifi/test/wifi-emlsr-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-emlsr-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -3344,12 +3577,22 @@
 EmlsrLinkSwitchTest::DoSetup()
 {
     Config::SetDefault("ns3::DefaultEmlsrManager::SwitchAuxPhy", BooleanValue(m_switchAuxPhy));
-    Config::SetDefault("ns3::EmlsrManager::ResetCamState", BooleanValue(m_resetCamState));
+    Config::SetDefault("ns3::EmlsrManager::ResetCamState",
+                       BooleanValue(m_resetCamStateAndInterruptSwitch));
+    Config::SetDefault("ns3::AdvancedEmlsrManager::InterruptSwitch",
+                       BooleanValue(m_resetCamStateAndInterruptSwitch));
     Config::SetDefault("ns3::EmlsrManager::AuxPhyChannelWidth", UintegerValue(m_auxPhyMaxChWidth));
     Config::SetDefault("ns3::WifiPhy::ChannelSwitchDelay", TimeValue(MicroSeconds(75)));
+    Config::SetDefault("ns3::EhtConfiguration::MediumSyncDuration", TimeValue(Time{0}));
 
     EmlsrOperationsTestBase::DoSetup();
 
+    m_errorModel = CreateObject<ListErrorModel>();
+    for (std::size_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
+    {
+        m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
+    }
+
     // use channels of different widths
     for (auto mac : std::initializer_list<Ptr<WifiMac>>{m_apMac, m_staMacs[0]})
     {
@@ -3437,18 +3680,59 @@
         // hence triggering yet another link switching on the EMLSR client
         m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(DOWNLINK, 0, 2, 1000));
         break;
+    case 4:
+        // block transmissions on all links at non-AP MLD side
+        m_staMacs[0]->GetMacQueueScheduler()->BlockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                          AC_BE,
+                                                          {WIFI_QOSDATA_QUEUE},
+                                                          m_apMac->GetAddress(),
+                                                          m_staMacs[0]->GetAddress(),
+                                                          {0},
+                                                          {0, 1, 2});
+        // unblock transmissions on the link used for ML setup (non-AP MLD side)
+        m_staMacs[0]->GetMacQueueScheduler()->UnblockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                            AC_BE,
+                                                            {WIFI_QOSDATA_QUEUE},
+                                                            m_apMac->GetAddress(),
+                                                            m_staMacs[0]->GetAddress(),
+                                                            {0},
+                                                            {m_mainPhyId});
+        // trigger establishment of BA agreement with AP as recipient
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 4, 1000));
+        break;
+    case 5:
+        // unblock transmissions on all links at non-AP MLD side
+        m_staMacs[0]->GetMacQueueScheduler()->UnblockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                            AC_BE,
+                                                            {WIFI_QOSDATA_QUEUE},
+                                                            m_apMac->GetAddress(),
+                                                            m_staMacs[0]->GetAddress(),
+                                                            {0},
+                                                            {0, 1, 2});
+        // block transmissions on the link used for ML setup (non-AP MLD side)
+        m_staMacs[0]->GetMacQueueScheduler()->BlockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                          AC_BE,
+                                                          {WIFI_QOSDATA_QUEUE},
+                                                          m_apMac->GetAddress(),
+                                                          m_staMacs[0]->GetAddress(),
+                                                          {0},
+                                                          {m_mainPhyId});
+        // generate a new data packet, which will be sent on a link other than the one
+        // used for ML setup, hence triggering a link switching on the EMLSR client
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
+        break;
     }
 }
 
 /**
- * AUX PHY switching enabled
+ * AUX PHY switching enabled (X = channel switch delay)
  *
  *  |--------- aux PHY A ---------|------ main PHY ------|-------------- aux PHY B -------------
  *                           ┌───┐     ┌───┐
  *                           │ICF│     │QoS│
  * ──────────────────────────┴───┴┬───┬┴───┴┬──┬────────────────────────────────────────────────
- *  [link 0]                       │CTS│     │BA│
- *                                 └───┘     └──┘
+ *  [link 0]                      │CTS│     │BA│
+ *                                └───┘     └──┘
  *
  *
  *  |--------- main PHY ----------|------------------ aux PHY A ----------------|--- main PHY ---
@@ -3466,8 +3750,28 @@
  *  [link 2]                                              │CTS│     │BA│
  *                                                        └───┘     └──┘
  *
+ * ... continued ...
+ *
+ *  |----------------------------------------- aux PHY B ---------------------------------------
+ * ─────────────────────────────────────────────────────────────────────────────────────────────
+ *  [link 0]
+ *
+ *  |--------- main PHY ----------|X|X|------------------------ aux PHY A ----------------------
+ *                 ┌───┐
+ *                 │ACK│
+ *  ──────────┬───┬┴───┴────────────────────────────────────────────────────────────────────────
+ *  [link 1]  │QoS│
+ *            └───┘
  *
- * AUX PHY switching disabled (X = main PHY channel switch delay)
+ *  |-------- aux PHY A ----------|X|---------------------- main PHY ---------------------------
+ *                                          ┌──┐
+ *                                          │BA│
+ *  ────────────────────────┬───X──────┬───┬┴──┴────────────────────────────────────────────────
+ *  [link 2]                │RTS│      │QoS│
+ *                          └───┘      └───┘
+ ************************************************************************************************
+ *
+ * AUX PHY switching disabled (X = channel switch delay)
  *
  *  |------------------------------------------ aux PHY A ---------------------------------------
  *                                |-- main PHY --|X|
@@ -3493,6 +3797,28 @@
  *  ─────────────────────────────────────────────────┴───┴┬───┬┴───┴┬──┬─────────────────────────
  *  [link 2]                                              │CTS│     │BA│
  *                                                        └───┘     └──┘
+ *
+ * ... continued ...
+ *
+ *  |----------------------------------------- aux PHY A ---------------------------------------
+ * ─────────────────────────────────────────────────────────────────────────────────────────────
+ *  [link 0]
+ *
+ *  |-------- main PHY --------|      |--- main PHY ---|
+ *                 ┌───┐
+ *                 │ACK│
+ *  ──────────┬───┬┴───┴────────────────────────────────────────────────────────────────────────
+ *  [link 1]  │QoS│
+ *            └───┘
+ *
+ *  |------------------------------------------ aux PHY B --------------------------------------
+ *                              |X||X|                 |X|-------------- main PHY --------------
+ *                                                   ┌───┐     ┌──┐
+ *                                                   │CTS│     │BA│
+ *  ────────────────────────┬───X───────────────┬───┬┴───┴┬───┬┴──┴─────────────────────────────
+ *  [link 2]                │RTS│               │RTS│     │QoS│
+ *                          └───┘               └───┘     └───┘
+ *
  */
 
 void
@@ -3500,14 +3826,16 @@
                                               const WifiTxVector& txVector,
                                               uint8_t linkId)
 {
-    if (m_txPsdusPos == 0)
+    if (++m_countIcfFrames == 1)
     {
-        // the iterator has not been set yet, thus we are not done with the establishment of
-        // the BA agreement
-        return;
+        m_txPsdusPos = m_txPsdus.size() - 1;
     }
 
-    NS_TEST_EXPECT_MSG_LT(m_countQoSframes, 4, "Unexpected number of ICFs");
+    // the first ICF is sent to protect ADDBA_REQ for DL BA agreement, then one ICF is sent before
+    // each of the 4 DL QoS Data frames; finally, another ICF is sent before the ADDBA_RESP for UL
+    // BA agreement. Hence, at any time the number of ICF sent is always greater than or equal to
+    // the number of QoS data frames sent.
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(m_countIcfFrames, m_countQoSframes, "Unexpected number of ICFs");
 
     auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
     auto phyRecvIcf = m_staMacs[0]->GetWifiPhy(linkId); // PHY receiving the ICF
@@ -3529,10 +3857,12 @@
                 << m_countQoSframes << " is operating on a channel whose width exceeds the limit");
     }
 
-    // if aux PHYs switch links, only the first ICF is received by the main PHY; otherwise,
-    // the first ICF and the last ICF are received by the main PHY
+    // the first two ICFs (before ADDBA_REQ and before first DL QoS Data) and the ICF before the
+    // ADDBA_RESP are received by the main PHY. If aux PHYs do not switch links, the ICF before
+    // the last DL QoS Data is also received by the main PHY
     NS_TEST_EXPECT_MSG_EQ((phyRecvIcf == mainPhy),
-                          (m_countQoSframes == 0 || (!m_switchAuxPhy && m_countQoSframes == 3)),
+                          (m_countIcfFrames == 1 || m_countIcfFrames == 2 ||
+                           (!m_switchAuxPhy && m_countIcfFrames == 5) || m_countIcfFrames == 6),
                           "Expecting that the ICF was received by the main PHY");
 
     // if aux PHYs do not switch links, the main PHY is operating on its original link when
@@ -3583,44 +3913,369 @@
 }
 
 void
+EmlsrLinkSwitchTest::CheckRtsFrame(const WifiConstPsduMap& psduMap,
+                                   const WifiTxVector& txVector,
+                                   uint8_t linkId)
+{
+    // corrupt the first RTS frame (sent by the EMLSR client)
+    if (++m_countRtsFrames == 1)
+    {
+        auto psdu = psduMap.begin()->second;
+        m_errorModel->SetList({psdu->GetPacket()->GetUid()});
+
+        // check that when CTS timeout occurs, the main PHY is switching
+        Simulator::Schedule(
+            m_staMacs[0]->GetFrameExchangeManager(linkId)->GetWifiTxTimer().GetDelayLeft(),
+            [=, this]() {
+                auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
+                NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
+                                      true,
+                                      "Main PHY expected to be in SWITCHING state instead of "
+                                          << mainPhy->GetState()->GetState());
+
+                // If main PHY channel switch can be interrupted, the main PHY should be back
+                // operating on the primary link after a channel switch delay. Otherwise, it
+                // will be operating on the primary link, if SwitchAuxPhy is false, or on the
+                // link used to send the RTS, if SwitchAuxPhy is true, after the remaining
+                // channel switching time plus the channel switch delay.
+                auto newLinkId =
+                    (m_resetCamStateAndInterruptSwitch || !m_switchAuxPhy) ? m_mainPhyId : linkId;
+                auto delay = mainPhy->GetChannelSwitchDelay();
+                if (!m_resetCamStateAndInterruptSwitch)
+                {
+                    delay += mainPhy->GetDelayUntilIdle();
+                }
+                Simulator::Schedule(delay + TimeStep(1), [=, this]() {
+                    auto id = m_staMacs[0]->GetLinkForPhy(mainPhy);
+                    NS_TEST_EXPECT_MSG_EQ(id.has_value(),
+                                          true,
+                                          "Expected main PHY to operate on a link");
+                    NS_TEST_EXPECT_MSG_EQ(*id,
+                                          newLinkId,
+                                          "Main PHY is operating on an unexpected link");
+                });
+            });
+    }
+    // block transmissions on all other links at non-AP MLD side
+    std::set<uint8_t> links{0, 1, 2};
+    links.erase(linkId);
+    m_staMacs[0]->GetMacQueueScheduler()->BlockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                      AC_BE,
+                                                      {WIFI_QOSDATA_QUEUE},
+                                                      m_apMac->GetAddress(),
+                                                      m_staMacs[0]->GetAddress(),
+                                                      {0},
+                                                      links);
+}
+
+void
 EmlsrLinkSwitchTest::CheckResults()
 {
     NS_TEST_ASSERT_MSG_NE(m_txPsdusPos, 0, "BA agreement establishment not completed");
 
-    const std::size_t nRxOk = 4; // successfully received ICFs
+    // Expected frame exchanges after ML setup and EML OMN exchange:
+    //  1. (DL) ICF + CTS + ADDBA_REQ + ACK
+    //  2. (UL) ADDBA_RESP + ACK
+    //  3. (DL) ICF + CTS + DATA + BA
+    //  4. (DL) ICF + CTS + DATA + BA
+    //  5. (DL) ICF + CTS + DATA + BA
+    //  6. (DL) ICF + CTS + DATA + BA
+    //  7. (UL) ADDBA_REQ + ACK
+    //  8. (DL) ICF + CTS + ADDBA_RESP + ACK
+    //  9. (UL) DATA + BA
+    // 10. (UL) RTS - CTS timeout
+    // 11. (UL) (RTS + CTS + ) DATA + BA
+
+    // frame exchange 11 is protected if SwitchAuxPhy is false or (SwitchAuxPhy is true and) the
+    // main PHY switch can be interrupted
+    bool fe11protected = !m_switchAuxPhy || m_resetCamStateAndInterruptSwitch;
+
+    NS_TEST_EXPECT_MSG_EQ(m_countIcfFrames, 6, "Unexpected number of ICFs sent");
+
+    // frame exchanges without RTS because the EMLSR client sent the initial frame through main PHY
+    const std::size_t nFrameExchNoRts = fe11protected ? 3 : 4;
+
+    const std::size_t nFrameExchWithRts = fe11protected ? 1 : 0;
 
     NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(),
-                                m_txPsdusPos + 2 + nRxOk * 4,
+                                m_txPsdusPos +
+                                    m_countIcfFrames * 4 + /* frames in frame exchange with ICF */
+                                    nFrameExchNoRts * 2 + /* frames in frame exchange without RTS */
+                                    nFrameExchWithRts * 4 + /* frames in frame exchange with RTS */
+                                    1,                      /* corrupted RTS */
                                 "Insufficient number of TX PSDUs");
 
-    // m_txPsdusPos points to ADDBA_RESPONSE, then ACK and then ICF
-    auto psduIt = std::next(m_txPsdus.cbegin(), m_txPsdusPos + 2);
+    // m_txPsdusPos points to the first ICF
+    auto psduIt = std::next(m_txPsdus.cbegin(), m_txPsdusPos);
+
+    const std::size_t nFrameExchanges =
+        m_countIcfFrames + nFrameExchNoRts + nFrameExchWithRts + 1 /* corrupted RTS */;
 
-    for (std::size_t i = 0; i < nRxOk; i++)
+    for (std::size_t i = 1; i <= nFrameExchanges; ++i)
     {
-        NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
-                               psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsTrigger()),
-                              true,
-                              "Expected a Trigger Frame (ICF)");
-        psduIt++;
-        NS_TEST_EXPECT_MSG_EQ(
-            (psduIt->psduMap.size() == 1 && psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsCts()),
-            true,
-            "Expected a CTS");
-        psduIt++;
-        NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
-                               psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsQosData()),
-                              true,
-                              "Expected a QoS Data frame");
-        psduIt++;
-        NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
-                               psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsBlockAck()),
-                              true,
-                              "Expected a BlockAck");
+        if (i == 1 || (i >= 3 && i <= 6) || i == 8 || i == 10 || (i == 11 && fe11protected))
+        {
+            // frame exchanges with protection
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   (i < 9 ? psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsTrigger()
+                                          : psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsRts())),
+                                  true,
+                                  "Expected a Trigger Frame (ICF)");
+            psduIt++;
+            if (i == 10)
+            {
+                continue; // corrupted RTS
+            }
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsCts()),
+                                  true,
+                                  "Expected a CTS");
+            psduIt++;
+        }
+
+        if (i == 1 || i == 2 || i == 7 || i == 8) // frame exchanges with ADDBA REQ/RESP frames
+        {
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsMgt()),
+                                  true,
+                                  "Expected a management frame");
+            psduIt++;
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsAck()),
+                                  true,
+                                  "Expected a Normal Ack");
+        }
+        else
+        {
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsQosData()),
+                                  true,
+                                  "Expected a QoS Data frame");
+            psduIt++;
+            NS_TEST_EXPECT_MSG_EQ((psduIt->psduMap.size() == 1 &&
+                                   psduIt->psduMap.at(SU_STA_ID)->GetHeader(0).IsBlockAck()),
+                                  true,
+                                  "Expected a BlockAck");
+        }
         psduIt++;
     }
 }
 
+EmlsrCcaBusyTest::EmlsrCcaBusyTest(uint16_t auxPhyMaxChWidth)
+    : EmlsrOperationsTestBase(std::string("Check EMLSR link switching (auxPhyMaxChWidth=") +
+                              std::to_string(auxPhyMaxChWidth) + "MHz )"),
+      m_auxPhyMaxChWidth(auxPhyMaxChWidth),
+      m_channelSwitchDelay(MicroSeconds(75)),
+      m_currMainPhyLinkId(0),
+      m_nextMainPhyLinkId(0)
+{
+    m_nEmlsrStations = 1;
+    m_nNonEmlsrStations = 1;
+    m_linksToEnableEmlsrOn = {0, 1, 2}; // enable EMLSR on all links right after association
+    m_mainPhyId = 1;
+    m_establishBaUl = true;
+    m_duration = Seconds(1.0);
+    m_transitionDelay = {MicroSeconds(128)};
+}
+
+void
+EmlsrCcaBusyTest::DoRun()
+{
+    Simulator::Stop(m_duration);
+    Simulator::Run();
+
+    Simulator::Destroy();
+}
+
+void
+EmlsrCcaBusyTest::DoSetup()
+{
+    Config::SetDefault("ns3::DefaultEmlsrManager::SwitchAuxPhy", BooleanValue(true));
+    Config::SetDefault("ns3::EmlsrManager::AuxPhyChannelWidth", UintegerValue(m_auxPhyMaxChWidth));
+    Config::SetDefault("ns3::EmlsrManager::AuxPhyMaxModClass", StringValue("EHT"));
+    Config::SetDefault("ns3::WifiPhy::ChannelSwitchDelay", TimeValue(m_channelSwitchDelay));
+
+    EmlsrOperationsTestBase::DoSetup();
+
+    // use channels of different widths
+    for (auto mac : std::initializer_list<Ptr<WifiMac>>{m_apMac, m_staMacs[0], m_staMacs[1]})
+    {
+        mac->GetWifiPhy(0)->SetOperatingChannel(
+            WifiPhy::ChannelTuple{4, 40, WIFI_PHY_BAND_2_4GHZ, 0});
+        mac->GetWifiPhy(1)->SetOperatingChannel(
+            WifiPhy::ChannelTuple{58, 80, WIFI_PHY_BAND_5GHZ, 0});
+        mac->GetWifiPhy(2)->SetOperatingChannel(
+            WifiPhy::ChannelTuple{79, 160, WIFI_PHY_BAND_6GHZ, 0});
+    }
+}
+
+void
+EmlsrCcaBusyTest::TransmitPacketToAp(uint8_t linkId)
+{
+    m_staMacs[1]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 1, 1, 2000));
+
+    // force the transmission of the packet to happen now on the given link.
+    // Multiple ScheduleNow calls are needed because Node::AddApplication() schedules a call to
+    // Application::Initialize(), which schedules a call to Application::StartApplication(), which
+    // schedules a call to PacketSocketClient::Send(), which finally generates the packet
+    Simulator::ScheduleNow([=, this]() {
+        Simulator::ScheduleNow([=, this]() {
+            Simulator::ScheduleNow([=, this]() {
+                m_staMacs[1]->GetFrameExchangeManager(linkId)->StartTransmission(
+                    m_staMacs[1]->GetQosTxop(AC_BE),
+                    m_staMacs[1]->GetWifiPhy(linkId)->GetChannelWidth());
+            });
+        });
+    });
+
+    // check that the other MLD started transmitting on the correct link
+    Simulator::Schedule(TimeStep(1), [=, this]() {
+        NS_TEST_EXPECT_MSG_EQ(m_staMacs[1]->GetWifiPhy(linkId)->IsStateTx(),
+                              true,
+                              "At time " << Simulator::Now().As(Time::NS)
+                                         << ", other MLD did not start transmitting on link "
+                                         << +linkId);
+    });
+}
+
+void
+EmlsrCcaBusyTest::StartTraffic()
+{
+    auto currMainPhyLinkId = m_staMacs[0]->GetLinkForPhy(m_mainPhyId);
+    NS_TEST_ASSERT_MSG_EQ(currMainPhyLinkId.has_value(),
+                          true,
+                          "Main PHY is not operating on any link");
+    m_currMainPhyLinkId = *currMainPhyLinkId;
+    m_nextMainPhyLinkId = (m_currMainPhyLinkId + 1) % 2;
+
+    // request the main PHY to switch to another link
+    m_staMacs[0]->GetEmlsrManager()->SwitchMainPhy(m_nextMainPhyLinkId,
+                                                   false,
+                                                   EmlsrManager::DONT_RESET_BACKOFF,
+                                                   EmlsrManager::DONT_REQUEST_ACCESS);
+
+    // the other MLD transmits a packet to the AP
+    TransmitPacketToAp(m_nextMainPhyLinkId);
+
+    // schedule another packet transmission slightly (10 us) before the end of aux PHY switch
+    Simulator::Schedule(m_channelSwitchDelay - MicroSeconds(10),
+                        &EmlsrCcaBusyTest::TransmitPacketToAp,
+                        this,
+                        m_currMainPhyLinkId);
+
+    // first checkpoint is after that the preamble of the PPDU has been received
+    Simulator::Schedule(MicroSeconds(8), &EmlsrCcaBusyTest::CheckPoint1, this);
+}
+
+/**
+ *                               ┌───────────────┐
+ *  [link X]                     │  other to AP  │CP3
+ * ──────────────────────────────┴───────────────┴──────────────────────────────────────────────
+ *  |------ main PHY ------|                  |------------------- aux PHY ---------------------
+ *                         .\_              _/
+ *                         .  \_          _/
+ *                         .    \_      _/
+ *                         .      \_  _/
+ *  [link Y]               . CP1    \/ CP2
+ *                         .┌───────────────┐
+ *                         .│  other to AP  │
+ * ─────────────────────────┴───────────────┴────────────────────────────────────────────────────
+ *  |------------ aux PHY ----------|---------------------- main PHY ----------------------------
+ *
+ */
+
+void
+EmlsrCcaBusyTest::CheckPoint1()
+{
+    // first checkpoint is after that the preamble of the first PPDU has been received
+    auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
+
+    // 1. Main PHY is switching
+    NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(), true, "Main PHY is not switching");
+
+    auto auxPhy = m_staMacs[0]->GetWifiPhy(m_nextMainPhyLinkId);
+    NS_TEST_EXPECT_MSG_NE(mainPhy, auxPhy, "Main PHY is operating on an unexpected link");
+
+    // 2. Aux PHY is receiving the PHY header
+    NS_TEST_EXPECT_MSG_EQ(auxPhy->IsReceivingPhyHeader(),
+                          true,
+                          "Aux PHY is not receiving a PHY header");
+
+    // 3. Main PHY dropped the preamble because it is switching
+    NS_TEST_EXPECT_MSG_EQ(mainPhy->IsReceivingPhyHeader(),
+                          false,
+                          "Main PHY is receiving a PHY header");
+
+    // 4. Channel access manager on destination link (Y) has been notified of CCA busy, but not
+    // until the end of transmission (main PHY dropped the preamble and notified CCA busy until
+    // end of transmission but the channel access manager on link Y does not yet have a listener
+    // attached to the main PHY; aux PHY notified CCA busy until the end of the PHY header field
+    // being received)
+    const auto caManager = m_staMacs[0]->GetChannelAccessManager(m_nextMainPhyLinkId);
+    const auto endTxTime = m_staMacs[1]->GetChannelAccessManager(m_nextMainPhyLinkId)->m_lastTxEnd;
+    NS_TEST_ASSERT_MSG_EQ(caManager->m_lastBusyEnd.contains(WIFI_CHANLIST_PRIMARY),
+                          true,
+                          "No CCA information for primary20 channel");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(
+        caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+        Simulator::Now(),
+        "ChannelAccessManager on destination link not notified of CCA busy");
+    NS_TEST_EXPECT_MSG_LT(
+        caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+        endTxTime,
+        "ChannelAccessManager on destination link notified of CCA busy until end of transmission");
+
+    // second checkpoint is after that the main PHY completed the link switch
+    Simulator::Schedule(mainPhy->GetDelayUntilIdle() + TimeStep(1),
+                        &EmlsrCcaBusyTest::CheckPoint2,
+                        this);
+}
+
+void
+EmlsrCcaBusyTest::CheckPoint2()
+{
+    // second checkpoint is after that the main PHY completed the link switch. The channel access
+    // manager on destination link (Y) is expected to be notified by the main PHY that medium is
+    // busy until the end of the ongoing transmission
+    const auto caManager = m_staMacs[0]->GetChannelAccessManager(m_nextMainPhyLinkId);
+    const auto endTxTime = m_staMacs[1]->GetChannelAccessManager(m_nextMainPhyLinkId)->m_lastTxEnd;
+    NS_TEST_ASSERT_MSG_EQ(caManager->m_lastBusyEnd.contains(WIFI_CHANLIST_PRIMARY),
+                          true,
+                          "No CCA information for primary20 channel");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(
+        caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+        Simulator::Now(),
+        "ChannelAccessManager on destination link not notified of CCA busy");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+                                endTxTime,
+                                "ChannelAccessManager on destination link not notified of CCA busy "
+                                "until end of transmission");
+
+    // third checkpoint is after that the aux PHY completed the link switch
+    Simulator::Schedule(m_channelSwitchDelay, &EmlsrCcaBusyTest::CheckPoint3, this);
+}
+
+void
+EmlsrCcaBusyTest::CheckPoint3()
+{
+    // third checkpoint is after that the aux PHY completed the link switch. The channel access
+    // manager on source link (X) is expected to be notified by the aux PHY that medium is
+    // busy until the end of the ongoing transmission (even if the aux PHY was not listening to
+    // link X when transmission started, its interface on link X recorded the transmission)
+    const auto caManager = m_staMacs[0]->GetChannelAccessManager(m_currMainPhyLinkId);
+    const auto endTxTime = m_staMacs[1]->GetChannelAccessManager(m_currMainPhyLinkId)->m_lastTxEnd;
+    NS_TEST_ASSERT_MSG_EQ(caManager->m_lastBusyEnd.contains(WIFI_CHANLIST_PRIMARY),
+                          true,
+                          "No CCA information for primary20 channel");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+                                Simulator::Now(),
+                                "ChannelAccessManager on source link not notified of CCA busy");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(caManager->m_lastBusyEnd[WIFI_CHANLIST_PRIMARY],
+                                endTxTime,
+                                "ChannelAccessManager on source link not notified of CCA busy "
+                                "until end of transmission");
+}
+
 WifiEmlsrTestSuite::WifiEmlsrTestSuite()
     : TestSuite("wifi-emlsr", Type::UNIT)
 {
@@ -3650,28 +4305,31 @@
                     TestCase::Duration::QUICK);
     }
 
-    for (auto genBackoffIfTxopWithoutTx : {true, false})
+    for (auto genBackoffAndUseAuxPhyCca : {true, false})
     {
         AddTestCase(new EmlsrUlTxopTest(
-                        {{0, 1, 2}, 40, 20, MicroSeconds(5504), 3, genBackoffIfTxopWithoutTx}),
+                        {{0, 1, 2}, 40, 20, MicroSeconds(5504), 3, genBackoffAndUseAuxPhyCca}),
                     TestCase::Duration::QUICK);
         AddTestCase(
-            new EmlsrUlTxopTest({{0, 1}, 40, 20, MicroSeconds(5504), 1, genBackoffIfTxopWithoutTx}),
+            new EmlsrUlTxopTest({{0, 1}, 40, 20, MicroSeconds(5504), 1, genBackoffAndUseAuxPhyCca}),
             TestCase::Duration::QUICK);
     }
 
     for (bool switchAuxPhy : {true, false})
     {
-        for (bool resetCamState : {true, false})
+        for (bool resetCamStateAndInterruptSwitch : {true, false})
         {
-            for (uint16_t auxPhyMaxChWidth : {20, 40, 80, 160})
+            for (MHz_u auxPhyMaxChWidth : {20, 40, 80, 160})
             {
-                AddTestCase(
-                    new EmlsrLinkSwitchTest({switchAuxPhy, resetCamState, auxPhyMaxChWidth}),
-                    TestCase::Duration::QUICK);
+                AddTestCase(new EmlsrLinkSwitchTest(
+                                {switchAuxPhy, resetCamStateAndInterruptSwitch, auxPhyMaxChWidth}),
+                            TestCase::Duration::QUICK);
             }
         }
     }
+
+    AddTestCase(new EmlsrCcaBusyTest(20), TestCase::Duration::QUICK);
+    AddTestCase(new EmlsrCcaBusyTest(80), TestCase::Duration::QUICK);
 }
 
 static WifiEmlsrTestSuite g_wifiEmlsrTestSuite; ///< the test suite
